<template>
	<div>
		<b-card v-if="!hasPermission('get:users')" bg-variant="danger">
			You do not have the permission to search for users.
		</b-card>
		<div v-if="hasPermission('get:users')" id="userSelectorMaineStreet">
			<b-collapse id="colUserSearch" v-model="user_is_selected_not">
				<b-card
					title="Select a User from MaineStreet"
					sub-title="Enter the search parameters, click on search, then filter if desired using the table column headers"
				>
					<b-card-body class="p-0">
						<div>
							<b-form @submit.prevent.stop="search_user" class="mx-auto w-50">
								<b-form-group
									id="frmUser"
									label="Emplid (fast) or Username (slow)"
									label-for="txtUser"
									description="Searches on emplid are exact, where searches on username are contains."
								>
									<b-form-input
										id="txtUser"
										v-model="user_input"
										required
										placeholder="Emplid or Username"
									></b-form-input>
								</b-form-group>

								<b-button
									id="btnSearchUsers"
									type="submit"
									variant="primary"
									:disabled="submit_disabled"
									>Search</b-button
								>
								<AdminHelpTooltip
									target="btnSearchUsers"
									permissions="get:users"
								/>
							</b-form>
						</div>
						<hr class="my-4" />
						<b-overlay :show="users_ms_fetching" rounded="sm">
							<b-table
								id="tblUserSelector"
								ref="tblUserSelector"
								:items="filtered"
								:fields="fields"
								striped
								small
								primary-key="code"
								:tbody-transition-props="transProps"
								selectable
								select-mode="single"
								@row-selected="rowSelected"
								:aria-hidden="users_ms_fetching ? 'true' : null"
							>
								<template slot="top-row" slot-scope="{ fields }">
									<td
										:class="field.class"
										v-for="field in fields"
										:key="field.key"
									>
										<label
											:for="'msUserSearch-' + field.key"
											v-if="field.sortable"
											class="sr-only"
											>{{ field.label }}</label
										>
										<input
											:id="'msUserSearch-' + field.key"
											v-model="filters[field.key]"
											:placeholder="field.label"
											size="10"
										/>
									</td>
								</template>
							</b-table>
						</b-overlay>
					</b-card-body>
				</b-card>
			</b-collapse>
			<b-collapse id="colSelectedUser" v-model="user_is_selected">
				<b-jumbotron
					header-tag="p"
					:header="selected_user_username"
					class="p-4"
				>
					<b-button
						:aria-expanded="user_is_selected"
						aria-controls="colUserSearch"
						@click="clear_selected_user"
					>
						Change User
					</b-button>
				</b-jumbotron>
			</b-collapse>
		</div>
		<AdminHelpTooltip
			target="userSelectorMaineStreet"
			permissions="get:users"
		/>
	</div>
</template>

<script>
import { mapGetters, mapActions, mapMutations } from "vuex";

export default {
	model: {
		prop: "value",
		event: "change"
	},
	props: {
		populate_globally_selected_emplid: {
			type: Boolean,
			default: true
		}
	},
	data() {
		return {
			local_user_input: "",
			transProps: {
				name: "flip-list"
			},
			filters: {
				lastName: "",
				firstName: "",
				middleName: "",
				username: "",
				emplid: "",
				email: ""
			},
			fields: [
				{ key: "lastName", label: "Last Name", sortable: true },
				{ key: "firstName", label: "First Name", sortable: true },
				{ key: "middleName", label: "Middle Name", sortable: true },
				{ key: "username", label: "username", sortable: true },
				{ key: "emplid", label: "Emplid", sortable: true },
				{ key: "email", label: "Email", sortable: true }
			],
			local_selected_emplid: "",
			local_selected_username: ""
		};
	},
	computed: {
		...mapGetters({
      users_ms_fetching: "UserSelectorMaineStreet/users_ms_fetching",
      users_ms: "UserSelectorMaineStreet/users_ms",
      user_search_id: "UserSelectorMaineStreet/user_search_id",
      selected_emplid: "selected_emplid",
      selected_username: "selected_username",
      hasPermission: "Navbar/hasPermission"
    }),
		user_input: {
			get() {
				return this.local_user_input;
			},
			set(value) {
				this.local_user_input = value;
				this.set_user_search_id(value);
			}
		},
		filtered() {
			return this.users_ms.filter(item => {
				return Object.keys(this.filters).every(key =>
					String(item[key].toLowerCase()).includes(
						this.filters[key].toLowerCase()
					)
				);
			});
		},
		submit_disabled() {
			return this.user_input.length === 0;
		},
		user_is_selected_not: {
			get() {
				return !this.user_is_selected;
			},
			set() {}
		},
		user_is_selected: {
			get() {
				return this.selected_user_emplid.length > 0;
			},
			set() {}
		},
		selected_user_emplid: {
			get() {
				return this.local_selected_emplid;
			},
			set(emplid) {
				this.local_selected_emplid = emplid;

				if (!(this.populate_globally_selected_emplid === false)) {
					this.set_selected_emplid(emplid);
				}
			}
		},
		selected_user_username: {
			get() {
				return this.local_selected_username;
			},
			set(username) {
				this.local_selected_username = username;

				if (!(this.populate_globally_selected_emplid === false)) {
					this.set_selected_username(username);
				}
			}
		}
	},
	methods: {
		...mapActions({
      get_users_ms:"UserSelectorMaineStreet/get_users_ms"
    }),
		...mapMutations({
      set_selected_emplid: "set_selected_emplid",
      set_user_search_id: "UserSelectorMaineStreet/set_user_search_id",
      set_selected_username: "set_selected_username"
    }),
		search_user() {
			this.get_users_ms({ user_id: this.user_input });
		},
		rowSelected(user) {
			if (user !== undefined && user[0] !== undefined) {
				this.set_selected_user_emplid(user[0].emplid);
				this.set_selected_user_username(user[0].username);

				this.$emit("change", this.local_selected_emplid);
			}
		},
		set_selected_user_emplid(emplid) {
			this.selected_user_emplid = emplid;
		},
		set_selected_user_username(username) {
			this.selected_user_username = username;
		},
		clear_selected_user() {
			this.set_selected_user_emplid("");
			this.set_selected_user_username("");
			this.$refs.tblUserSelector.clearSelected();
			this.$emit("change", this.local_selected_emplid);
		}
	},
	mounted() {
		if (!(this.populate_globally_selected_emplid === false)) {
			this.local_selected_emplid = this.selected_emplid;
			this.local_selected_username = this.selected_username;
		}

		this.user_input = this.user_search_id;
	}
};
</script>
